exports.install = function(framework) {
	framework.route('/', view_homepage);
	framework.route('/', login, ['json']);

    framework.route('/home/', view_index_logged, ['logged', '!admin', '!moderator']);
    framework.route('/home/', view_index_unlogged);

    framework.route('/home/admin/', view_roles_admin, ['logged', '!admin']);
    framework.route('/home/moderator/', view_roles_moderator, ['logged', '!moderator']);

    framework.route('/logoff/', redirect_logoff);
};

function redirect_logoff() {
    var self = this;
    var auth = self.module('authorization');
    var user = self.user;

    if (user !== null) {
        console.log('USER -> LOGOFF:', user.id);
        auth.logoff(self, user.id);
    }
   self.view('loggedoff');
}

function view_homepage() {
	var self = this;
	self.view('homepage');
}

function login() {

    var self = this;
    var auth = self.module('authorization');

    var id = self.post.id;
    var password = self.post.password;

    var filter = function(doc) {
        return doc.email === id && doc.password === password;
    };

    self.database('users').one(filter, function(user) {
        
        console.log('Checking Authorization of user id:', id);
        
        if (user !== null) {
            console.log('Found:', user);
            auth.login(self, user.id, user);
        }

        self.json({ success: user !== null });
    });
}

function view_index_logged() {
    var self = this;
    console.log('VIEW: logged');
    self.view('home');
}

function view_index_unlogged() {
    var self = this;
    console.log('VIEW: unlogged');
    self.view('homepage');
}

function view_roles_admin() {
    var self = this;
    self.view('adminonly');
}

function view_roles_moderator() {
    var self = this;
    self.plain('Only admins and moderators.');
}